;;; Funktion: Bezugslinien mit Positionsnummern schreiben
;;; 9/2003    V 2 (d) Schoenwald

(defun C:POS_NUM (/ NUM P1 P2 DXX DX DYY DY)

 (defun NEUERR (MSG) (R_VAR) (princ MSG) (princ))

 (setq ALTERR  *ERROR*
       *ERROR* NEUERR
       C_E     (getvar "CMDECHO")       ; ECHO
       C_L     (getvar "CLAYER")        ; LAYER
       P_M     (getvar "PDMODE")        ; Punktmuster
       P_S     (getvar "PDSIZE")        ; Punktgroesse
 )

 (setvar "CMDECHO" 0)
 (setvar "ATTDIA" 0)
 (if (not (tblsearch "LAYER" "2"))
  (command "LAYER" "MACH" "2" "FA" "2" "" "") ; Layer und Farbe
 )
 (setq NUM NIL)

 (defun R_VAR ()
  (setq *ERROR* ALTERR)
  (setvar "PDMODE" P_M)
  (setvar "PDSIZE" P_S)
  (command "LAYER" "SE" C_L "" "REGEN")
  (setvar "CMDECHO" C_E)
  (setq NUM NIL)
 )
 ;;-------------------------------------
 (setq NUM 1
       WEITER t
 )
 (while WEITER
  (prompt "\n. \n. \n")
  (princ "\n \nBauteilnummer oder 0 fr Ende 0/<") ; anzeigen
  (princ NUM)                           ; Vorgabenummer
  (setq TEMP (getint ">: "))            ; abfragen
  (if (= TEMP 0)
   (setq WEITER NIL)
   (progn
    (if TEMP
     (setq NUM TEMP)
    )                                   ; wenn nicht return
    (setq P1
          (getpoint "\n. \n. \nReturn fr Exit/Startpunkt der Linie anklicken: "
          )
    )
    (if P1
     (progn
      (initget 1)
      (setq P2 (getpoint "\n. \n. \nEndpunkt der Linie anklicken: "))
      (initget "J N")
      (setq PU
            (getkword "\n: \n. \n. \nPunkt am Anfang der Linie setzen? N/<J>: "
            )
      )
      (if (not (= PU "N"))
       ;; Layer, Punktsymbol und -Durchmesser setzen
       (command "LAYER" "SE" "0" "" "PDMODE" "33" "PDSIZE" "0.4" ".PUNKT" P1)
      )
      (command "LAYER" "SE" "2" "" "_LINE" P1 P2 "")
     ) ;_ end progn
     (progn
      (setq WEITER NIL
            P2 NIL
      )
     )
    ) ;_ end if p1

    (if P2
     (progn
      (setq DXX (- (car P2) (car P1))
            DX  (- (car P1) (car P2))
            DYY (- (cadr P2) (cadr P1))
            DY  (- (cadr P1) (cadr P2))
      )
      (if (and (> DYY DXX) (> DXX DY) (> DYY DX)) ; Linie von oben
       (setq P (list (car P2) (+ (cadr P2) 4)))
      )
      (if (and (> DY DYY) (> DY DX))    ; ... unten
       (setq P (list (car P2) (- (cadr P2) 9)))
      )
      (if (and (> DXX DX) (> DXX DYY) (> DYY DX)) ; ... links
       (setq P (list (+ (car P2) 6) (- (cadr P2) 2)))
      )
      (if (and (> DX DYY) (> DX DY) (or (> DYY DY) (> DY DYY))) ; rechts
       (setq P (list (- (car P2) 6) (- (cadr P2) 2)))
      )
      (command "LAYER" "SE" "0" "" "TEXT" P "5" "0" (itoa NUM))
     ) ;_end progn
    ) ;_end if
    (setq NUM (1+ NUM))
   )
  )
 ) ;_ end while weiter
 (R_VAR)
 (princ)
)                                       ; end defun c:...
(princ)

